// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S160_ReferencesEuropeanLegislation.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S160_ReferencesEuropeanLegislation extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int referenceState = 4;
  public static final int propagateAuthorityState = 6;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3, 3
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\5\2\0\1\6"+
    "\1\5\1\0\1\7\12\10\1\11\1\12\5\0\1\13"+
    "\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\24"+
    "\1\33\1\34\1\35\1\36\1\37\1\40\1\24\1\41"+
    "\1\24\1\42\1\0\1\43\1\0\1\44\1\0\1\45"+
    "\1\46\1\47\1\50\1\51\1\52\1\53\1\54\1\55"+
    "\1\0\1\56\1\57\1\60\1\61\1\62\1\63\1\0"+
    "\1\64\1\65\1\66\1\67\1\70\1\71\1\0\1\72"+
    "\266\0\2\55\115\0\1\65\u0182\0\1\1\20\0\2\5"+
    "\u0115\0\1\56\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\4\0\2\1\2\2\4\3\2\4\25\0\1\5\123\0"+
    "\1\6\255\0\1\6\12\0\1\7\1\0\1\10\10\0"+
    "\1\11\1\7\5\0\1\12\251\0\1\13\150\0\1\14"+
    "\325\0\1\14\13\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[823];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\73\0\166\0\261\0\354\0\u0127\0\354\0\u0162"+
    "\0\354\0\u019d\0\u01d8\0\u0213\0\354\0\u024e\0\u0289\0\u02c4"+
    "\0\u019d\0\u01d8\0\u02ff\0\u033a\0\u0375\0\u03b0\0\u03eb\0\u0426"+
    "\0\u0461\0\u049c\0\u04d7\0\u0512\0\u054d\0\u0588\0\u05c3\0\u05fe"+
    "\0\u0639\0\u0674\0\u06af\0\354\0\u06ea\0\u0725\0\u0760\0\u079b"+
    "\0\u07d6\0\u0811\0\u084c\0\u0887\0\u08c2\0\u08fd\0\u0938\0\u0973"+
    "\0\u09ae\0\u09e9\0\u0a24\0\u0a5f\0\u0a9a\0\u0ad5\0\u0b10\0\u0b4b"+
    "\0\u0b86\0\u0bc1\0\u0bfc\0\u0c37\0\u0c72\0\u0cad\0\u0ce8\0\u0d23"+
    "\0\u0d5e\0\u0d99\0\u0dd4\0\u0e0f\0\u0e4a\0\u0e85\0\u0ec0\0\u0efb"+
    "\0\u0f36\0\u0f71\0\u0fac\0\u0fe7\0\u1022\0\u105d\0\u1098\0\u10d3"+
    "\0\u110e\0\u1149\0\u1184\0\u11bf\0\u11fa\0\u1235\0\u1270\0\u12ab"+
    "\0\u12e6\0\u1321\0\u135c\0\u1397\0\u13d2\0\u140d\0\u1448\0\u1483"+
    "\0\u14be\0\u14f9\0\u1534\0\u156f\0\u15aa\0\u15e5\0\u1620\0\u165b"+
    "\0\u1696\0\u16d1\0\u170c\0\u1747\0\u1782\0\u17bd\0\u17f8\0\u1833"+
    "\0\u186e\0\u18a9\0\u18e4\0\u191f\0\u195a\0\u1995\0\u19d0\0\354"+
    "\0\u1a0b\0\u1a46\0\u1a81\0\u1abc\0\u1af7\0\u1b32\0\u1b6d\0\u1ba8"+
    "\0\u1be3\0\u1c1e\0\u1c59\0\u1c94\0\u1ccf\0\u1d0a\0\u1d45\0\u1d80"+
    "\0\u1dbb\0\u1df6\0\u1e31\0\u1e6c\0\u1ea7\0\u1ee2\0\u1f1d\0\u1f58"+
    "\0\u1f93\0\u1fce\0\u2009\0\u2044\0\u207f\0\u20ba\0\u20f5\0\u2130"+
    "\0\u216b\0\u21a6\0\u21e1\0\u221c\0\u2257\0\u2292\0\u22cd\0\u2308"+
    "\0\u2343\0\u237e\0\u23b9\0\u23f4\0\u242f\0\u246a\0\u24a5\0\u24e0"+
    "\0\u251b\0\u2556\0\u2591\0\u25cc\0\u2607\0\u2642\0\u267d\0\u26b8"+
    "\0\u26f3\0\u272e\0\u2769\0\u27a4\0\u27df\0\u281a\0\u2855\0\u2890"+
    "\0\u28cb\0\u2906\0\u2941\0\u297c\0\u29b7\0\u29f2\0\u2a2d\0\u2a68"+
    "\0\u2aa3\0\u2ade\0\u2b19\0\u2b54\0\u2b8f\0\u2bca\0\u2c05\0\u2c40"+
    "\0\u2c7b\0\u2cb6\0\u2cf1\0\u2d2c\0\u2d67\0\u2da2\0\u2ddd\0\u2e18"+
    "\0\u2e53\0\u2e8e\0\u2ec9\0\u2f04\0\u2f3f\0\u2f7a\0\u2fb5\0\u2ff0"+
    "\0\u302b\0\u3066\0\u30a1\0\u30dc\0\u3117\0\u3152\0\u318d\0\u31c8"+
    "\0\u3203\0\u323e\0\u3279\0\u32b4\0\u32ef\0\u332a\0\u3365\0\u33a0"+
    "\0\u33db\0\u3416\0\u3451\0\u348c\0\u34c7\0\u3502\0\u353d\0\u3578"+
    "\0\u35b3\0\u35ee\0\u3629\0\u3664\0\u369f\0\u36da\0\u3715\0\u3750"+
    "\0\u378b\0\u37c6\0\u3801\0\u383c\0\u3877\0\u38b2\0\u38ed\0\u3928"+
    "\0\u3963\0\u399e\0\u39d9\0\u3a14\0\u3a4f\0\u3a8a\0\u3ac5\0\u3b00"+
    "\0\u3b3b\0\u3b76\0\u3bb1\0\u3bec\0\u3c27\0\u3c62\0\u3c9d\0\u3cd8"+
    "\0\u3d13\0\u3d4e\0\u3d89\0\u3dc4\0\u3dff\0\u3e3a\0\u3e75\0\u3eb0"+
    "\0\u3eeb\0\u3f26\0\u3f61\0\u3f9c\0\u3fd7\0\u4012\0\u404d\0\u4088"+
    "\0\u40c3\0\u40fe\0\u4139\0\u4174\0\u41af\0\u41ea\0\u41ea\0\u4225"+
    "\0\u4260\0\u429b\0\u42d6\0\u4311\0\u434c\0\u4387\0\u43c2\0\u43fd"+
    "\0\354\0\u4438\0\354\0\u4473\0\u44ae\0\u44e9\0\u4524\0\u455f"+
    "\0\u459a\0\u45d5\0\u4610\0\354\0\u464b\0\u4686\0\u46c1\0\u464b"+
    "\0\u46fc\0\u4737\0\354\0\u4772\0\u47ad\0\u47e8\0\u4823\0\u485e"+
    "\0\u4899\0\u48d4\0\u490f\0\u494a\0\u4985\0\u49c0\0\u49fb\0\u4a36"+
    "\0\u4a71\0\u4aac\0\u4ae7\0\u4b22\0\u4b5d\0\u4b98\0\u4bd3\0\u4c0e"+
    "\0\u4c49\0\u4c84\0\u4cbf\0\u4cfa\0\u4d35\0\u4d70\0\u4dab\0\u4de6"+
    "\0\u4e21\0\u4e5c\0\u4e97\0\u4ed2\0\u4f0d\0\u4f48\0\u4f83\0\u4fbe"+
    "\0\u4ff9\0\u5034\0\u506f\0\u50aa\0\u50e5\0\u5120\0\u515b\0\u5196"+
    "\0\u51d1\0\u520c\0\u5247\0\u5282\0\u52bd\0\u52f8\0\u5333\0\u536e"+
    "\0\u53a9\0\u53e4\0\u541f\0\u545a\0\u5495\0\u54d0\0\u550b\0\u5546"+
    "\0\u5581\0\u55bc\0\u55f7\0\u5632\0\u566d\0\u56a8\0\u56e3\0\u571e"+
    "\0\u5759\0\u5794\0\u57cf\0\u580a\0\u5845\0\u5880\0\u58bb\0\u58f6"+
    "\0\u5931\0\u596c\0\u59a7\0\u59e2\0\u5a1d\0\u5a58\0\u5a93\0\u5ace"+
    "\0\u5b09\0\u5b44\0\u5b7f\0\u5bba\0\u5bf5\0\u5c30\0\u5c6b\0\u5ca6"+
    "\0\u5ce1\0\u5d1c\0\u5d57\0\u5d92\0\u5dcd\0\u5e08\0\u5e43\0\u5e7e"+
    "\0\u5eb9\0\u5ef4\0\u5f2f\0\u5f6a\0\u5fa5\0\u5fe0\0\u601b\0\u6056"+
    "\0\u6091\0\u60cc\0\u6107\0\u6142\0\u617d\0\u61b8\0\u61f3\0\u622e"+
    "\0\u6269\0\u62a4\0\u62df\0\u631a\0\u6355\0\u6390\0\u63cb\0\u6406"+
    "\0\u6441\0\u647c\0\u64b7\0\u64f2\0\u652d\0\u6568\0\u65a3\0\u65de"+
    "\0\u6619\0\u6654\0\u668f\0\u66ca\0\u6705\0\u6740\0\u677b\0\u67b6"+
    "\0\u67f1\0\u682c\0\u6867\0\u68a2\0\u68dd\0\u6918\0\u6953\0\u698e"+
    "\0\u69c9\0\u6a04\0\u6a3f\0\u6a7a\0\u6ab5\0\u6af0\0\u6b2b\0\u6b66"+
    "\0\u6ba1\0\u6bdc\0\u6c17\0\u6c52\0\u6c8d\0\u6cc8\0\u6d03\0\u6d3e"+
    "\0\u6d79\0\u6db4\0\u6def\0\u6e2a\0\354\0\u6e65\0\u6ea0\0\u6edb"+
    "\0\u6f16\0\u6f51\0\u6f8c\0\u6fc7\0\u7002\0\u703d\0\u7078\0\u70b3"+
    "\0\u70ee\0\u7129\0\u7164\0\u719f\0\u71da\0\u7215\0\u7250\0\u728b"+
    "\0\u72c6\0\u7301\0\u733c\0\u7377\0\u73b2\0\u73ed\0\u7428\0\u7463"+
    "\0\u749e\0\u74d9\0\u7514\0\u754f\0\u758a\0\u75c5\0\u7600\0\u763b"+
    "\0\u7676\0\u76b1\0\u76ec\0\u7727\0\u7762\0\u779d\0\u77d8\0\u7813"+
    "\0\u784e\0\u7889\0\u78c4\0\u78ff\0\u793a\0\u7975\0\u79b0\0\u79eb"+
    "\0\u7a26\0\u7a61\0\u7a9c\0\u7ad7\0\u7b12\0\u7b4d\0\u7b88\0\u7bc3"+
    "\0\u7bfe\0\u7c39\0\u7c74\0\u7caf\0\u7cea\0\u7d25\0\u7d60\0\u7d9b"+
    "\0\u7dd6\0\u7e11\0\u7e4c\0\u7e87\0\u7ec2\0\u7efd\0\u7f38\0\u7f73"+
    "\0\u7fae\0\u7fe9\0\u8024\0\u805f\0\u809a\0\u80d5\0\u8110\0\u814b"+
    "\0\u8186\0\u81c1\0\u81fc\0\u8237\0\u8272\0\u82ad\0\u82e8\0\u8323"+
    "\0\u835e\0\u8399\0\u83d4\0\u840f\0\u844a\0\u8485\0\u84c0\0\u84fb"+
    "\0\u8536\0\u8571\0\u85ac\0\u85e7\0\u8622\0\u865d\0\u8698\0\u86d3"+
    "\0\u870e\0\u8749\0\u8784\0\u87bf\0\u87fa\0\u8835\0\u8870\0\u88ab"+
    "\0\u88e6\0\u8921\0\u865d\0\u895c\0\u8997\0\u89d2\0\u8a0d\0\u8a48"+
    "\0\u8a83\0\u8abe\0\u8af9\0\u8b34\0\u8b6f\0\u8baa\0\u8be5\0\u8c20"+
    "\0\u8c5b\0\u8c96\0\u8cd1\0\u8d0c\0\u8d47\0\u8d82\0\u8dbd\0\u8df8"+
    "\0\u8e33\0\u8e6e\0\u8ea9\0\u8ee4\0\u8f1f\0\u8f5a\0\u8f95\0\u8fd0"+
    "\0\u900b\0\u9046\0\u9081\0\u90bc\0\u90f7\0\u9132\0\u916d\0\u91a8"+
    "\0\u91e3\0\u921e\0\u9259\0\u9294\0\u92cf\0\u930a\0\u9345\0\u9380"+
    "\0\u93bb\0\u93f6\0\u9431\0\u946c\0\u94a7\0\u94e2\0\u951d\0\u9558"+
    "\0\u9593\0\u95ce\0\u9609\0\u9644\0\u967f\0\u96ba\0\u96f5\0\u9730"+
    "\0\u976b\0\u97a6\0\u97e1\0\u981c\0\u9857\0\u9892\0\u98cd\0\u9908"+
    "\0\u9943\0\u997e\0\u99b9\0\u99f4\0\u9a2f\0\u9a6a\0\u9aa5\0\u9ae0"+
    "\0\u9b1b\0\u9b56\0\u9b91\0\u9bcc\0\u9c07\0\u9c42\0\u9c7d\0\u9cb8"+
    "\0\u9cf3\0\u9d2e\0\u9d69\0\u9da4\0\u9ddf\0\u9e1a\0\u9e55\0\u9e90"+
    "\0\u9ecb\0\u9f06\0\u9f41\0\u9f7c\0\u9fb7\0\u9ff2\0\ua02d\0\ua068"+
    "\0\ua0a3\0\ua0de\0\ua119\0\ua154\0\ua18f\0\ua1ca\0\ua205\0\ua240"+
    "\0\ua27b\0\ua2b6\0\ua2f1\0\ua32c\0\ua367\0\ua3a2\0\ua3dd\0\ua418"+
    "\0\ua453\0\ua48e\0\ua4c9\0\ua504\0\ua53f\0\ua57a\0\ua5b5\0\ua5f0"+
    "\0\ua62b\0\ua666\0\ua6a1\0\ua6dc\0\ua717\0\ua752\0\ua78d\0\ua7c8"+
    "\0\ua803\0\ua83e\0\ua879\0\ua8b4\0\ua8ef\0\ua92a\0\ua965\0\ua9a0"+
    "\0\ua9db\0\uaa16\0\uaa51\0\uaa8c\0\uaac7\0\uab02\0\uab3d\0\uab78"+
    "\0\uabb3\0\uabee\0\uac29\0\uac64\0\uac9f\0\uacda\0\uad15\0\uad50"+
    "\0\uad8b\0\uadc6\0\uae01\0\uae3c\0\uae77\0\uaeb2\0\uaeed\0\uaf28"+
    "\0\uaf63\0\uaf9e\0\uafd9\0\ub014\0\ub04f\0\ub08a\0\ub0c5\0\ub100"+
    "\0\ub13b\0\ub176\0\ub1b1\0\ub1ec\0\ub227\0\ub262\0\ub29d\0\ub2d8"+
    "\0\ub313\0\ub34e\0\ub389\0\ub3c4\0\ub3ff\0\ub43a\0\ub475\0\ub4b0"+
    "\0\ub4eb\0\ub526\0\ub561\0\ub59c\0\ub5d7\0\ub612\0\ub64d\0\ub688"+
    "\0\ub6c3\0\ub6fe\0\ub739\0\u7d9b\0\ub774\0\ub7af\0\ub7ea\0\ub825"+
    "\0\ub860\0\ub89b\0\ub8d6\0\ub911\0\ub94c\0\ub987\0\ub9c2";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[823];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\42\5\1\6\30\5\42\7\1\10\30\7\1\11\2\12"+
    "\1\11\1\13\1\11\1\12\33\11\1\14\30\11\42\15"+
    "\1\16\30\15\121\0\1\17\30\0\1\17\22\0\1\20"+
    "\64\0\2\21\1\0\1\22\1\0\1\21\33\0\1\23"+
    "\60\0\1\24\30\0\1\24\37\0\1\25\30\0\1\25"+
    "\41\0\1\26\30\0\1\26\40\0\1\27\30\0\1\27"+
    "\42\0\1\30\30\0\1\30\41\0\1\31\30\0\1\31"+
    "\27\0\1\32\31\0\1\32\51\0\1\33\30\0\1\33"+
    "\41\0\1\34\30\0\1\34\44\0\1\35\30\0\1\35"+
    "\36\0\1\36\30\0\1\36\41\0\1\37\30\0\1\37"+
    "\50\0\1\40\30\0\1\40\35\0\1\41\30\0\1\41"+
    "\41\0\1\42\30\0\1\42\22\0\1\43\111\0\1\44"+
    "\30\0\1\44\41\0\1\45\30\0\1\45\43\0\1\46"+
    "\30\0\1\46\20\0\1\47\72\0\1\50\74\0\3\51"+
    "\1\52\1\53\6\51\1\54\13\51\2\0\1\51\3\0"+
    "\1\55\1\56\5\0\1\57\24\0\1\60\73\0\1\21"+
    "\73\0\1\61\2\0\1\62\1\63\1\64\5\0\1\65"+
    "\1\0\1\66\3\0\1\67\4\0\1\70\3\0\1\61"+
    "\2\0\1\62\1\63\1\64\4\0\1\65\1\0\1\66"+
    "\3\0\1\67\4\0\1\70\13\0\1\71\3\0\1\72"+
    "\6\0\1\73\5\0\1\74\10\0\1\71\3\0\1\72"+
    "\5\0\1\73\5\0\1\74\16\0\1\75\1\0\27\51"+
    "\2\0\1\51\37\0\1\75\1\0\16\51\1\76\10\51"+
    "\2\0\1\51\15\0\1\77\21\0\1\75\1\0\23\51"+
    "\1\100\3\51\2\0\1\51\22\0\1\101\14\0\1\75"+
    "\1\0\4\51\1\102\22\51\2\0\1\51\4\0\1\103"+
    "\52\0\1\77\30\0\1\77\46\0\1\101\30\0\1\101"+
    "\22\0\1\103\31\0\1\103\55\0\1\104\30\0\1\104"+
    "\43\0\1\105\30\0\1\105\34\0\1\106\30\0\1\106"+
    "\46\0\1\107\30\0\1\107\41\0\1\110\30\0\1\110"+
    "\22\0\1\111\31\0\1\111\57\0\1\112\30\0\1\112"+
    "\40\0\1\113\30\0\1\113\23\0\1\114\31\0\1\114"+
    "\57\0\1\115\30\0\1\115\41\0\1\116\30\0\1\116"+
    "\22\0\1\117\31\0\1\117\56\0\1\120\30\0\1\120"+
    "\4\0\2\75\2\0\5\75\1\121\30\75\2\0\27\75"+
    "\11\0\1\75\1\0\2\51\1\122\24\51\2\0\1\51"+
    "\2\0\1\123\40\0\1\123\31\0\1\123\34\0\1\75"+
    "\1\0\27\51\2\0\1\124\72\0\1\125\37\0\1\75"+
    "\1\0\6\51\1\126\20\51\2\0\1\51\6\0\1\127"+
    "\40\0\1\127\31\0\1\127\54\0\1\130\30\0\1\130"+
    "\41\0\1\131\30\0\1\131\21\0\1\132\31\0\1\132"+
    "\67\0\1\133\54\0\1\134\30\0\1\134\34\0\1\135"+
    "\31\0\1\135\46\0\1\136\30\0\1\136\44\0\1\137"+
    "\30\0\1\137\22\0\1\140\31\0\1\140\62\0\1\141"+
    "\30\0\1\141\50\0\1\142\47\0\1\143\31\0\1\143"+
    "\51\0\1\144\30\0\1\144\17\0\1\145\73\0\1\75"+
    "\1\0\22\51\1\146\4\51\2\0\1\51\21\0\1\147"+
    "\41\0\1\147\30\0\1\147\15\0\1\75\1\0\3\51"+
    "\1\52\7\51\1\54\13\51\2\0\1\51\3\0\1\55"+
    "\6\0\1\57\31\0\1\55\7\0\1\57\21\0\1\55"+
    "\6\0\1\57\24\0\1\75\1\0\27\51\2\0\1\150"+
    "\72\0\1\151\60\0\1\152\30\0\1\152\31\0\1\153"+
    "\31\0\1\153\53\0\1\154\6\0\1\155\21\0\1\154"+
    "\17\0\1\156\2\0\1\157\7\0\1\65\16\0\1\156"+
    "\2\0\1\157\6\0\1\65\41\0\1\160\30\0\1\160"+
    "\57\0\1\161\42\0\1\162\31\0\1\162\64\0\1\163"+
    "\30\0\1\163\34\0\1\164\30\0\1\164\30\0\1\165"+
    "\31\0\1\165\31\0\1\71\12\0\1\73\16\0\1\71"+
    "\11\0\1\73\57\0\1\166\66\0\1\167\30\0\1\167"+
    "\11\0\1\145\32\0\1\170\40\0\1\75\1\0\26\51"+
    "\1\171\2\0\1\51\25\0\1\172\41\0\1\172\30\0"+
    "\1\172\11\0\1\75\1\0\3\51\1\52\23\51\2\0"+
    "\1\51\3\0\1\55\40\0\1\55\31\0\1\55\62\0"+
    "\1\173\30\0\1\173\12\0\1\174\122\0\1\175\30\0"+
    "\1\175\16\0\1\176\31\0\1\176\37\0\1\177\20\0"+
    "\1\105\10\0\1\177\17\0\1\105\34\0\1\200\30\0"+
    "\1\200\54\0\1\201\41\0\1\61\2\0\1\157\26\0"+
    "\1\61\2\0\1\157\41\0\1\202\31\0\1\202\32\0"+
    "\1\203\72\0\1\204\72\0\1\205\74\0\1\71\31\0"+
    "\1\71\36\0\1\206\72\0\1\75\1\0\17\51\1\207"+
    "\7\51\2\0\1\51\16\0\1\210\41\0\1\210\30\0"+
    "\1\210\20\0\1\211\75\0\1\212\1\213\14\0\1\214"+
    "\13\0\1\212\1\213\13\0\1\214\41\0\1\215\30\0"+
    "\1\215\22\0\1\216\31\0\1\216\60\0\1\217\30\0"+
    "\1\217\23\0\1\220\31\0\1\220\42\0\1\221\31\0"+
    "\1\221\54\0\1\222\30\0\1\222\6\0\2\223\2\0"+
    "\5\223\1\224\17\223\1\225\10\223\2\0\16\223\1\225"+
    "\10\223\2\204\2\0\5\204\1\226\30\204\2\0\27\204"+
    "\14\0\1\227\1\230\14\0\1\231\13\0\1\227\1\230"+
    "\13\0\1\231\40\0\1\232\30\0\1\232\21\0\1\75"+
    "\1\0\4\51\1\233\22\51\2\0\1\51\4\0\1\234"+
    "\40\0\1\234\31\0\1\234\52\0\1\235\30\0\1\235"+
    "\25\0\1\236\31\0\1\236\54\0\1\237\30\0\1\237"+
    "\23\0\1\240\31\0\1\240\44\0\1\241\31\0\1\241"+
    "\56\0\1\242\30\0\1\242\35\0\1\243\30\0\1\243"+
    "\45\0\1\154\30\0\1\154\42\0\1\244\30\0\1\244"+
    "\14\0\1\245\32\0\1\246\26\0\2\223\2\0\5\223"+
    "\1\224\30\223\2\0\27\223\10\0\1\247\62\0\2\223"+
    "\2\0\5\223\1\224\6\223\1\250\21\223\2\0\6\223"+
    "\1\250\20\223\10\0\1\251\77\0\1\252\31\0\1\252"+
    "\54\0\1\253\30\0\1\253\23\0\1\254\31\0\1\254"+
    "\45\0\1\255\31\0\1\255\31\0\1\256\1\0\27\51"+
    "\2\0\1\51\37\0\1\257\101\0\1\260\31\0\1\260"+
    "\37\0\1\261\31\0\1\261\50\0\1\262\1\263\27\0"+
    "\1\262\1\263\44\0\1\264\30\0\1\264\17\0\1\265"+
    "\100\0\1\164\31\0\1\164\51\0\1\266\30\0\1\266"+
    "\55\0\1\267\26\0\2\245\2\0\5\245\1\270\30\245"+
    "\2\0\27\245\41\0\1\271\30\0\1\271\10\0\1\247"+
    "\32\0\1\272\27\0\2\223\2\0\5\223\1\273\30\223"+
    "\2\0\27\223\10\0\1\251\32\0\1\274\46\0\1\275"+
    "\31\0\1\275\50\0\1\276\1\277\27\0\1\276\1\277"+
    "\44\0\1\300\30\0\1\300\17\0\1\224\61\0\2\75"+
    "\2\0\5\75\1\121\4\75\1\301\4\75\1\302\6\75"+
    "\1\303\1\304\6\75\2\0\4\75\1\301\4\75\1\302"+
    "\5\75\1\303\1\304\6\75\16\0\1\305\4\0\1\306"+
    "\6\0\1\307\1\310\14\0\1\305\4\0\1\306\5\0"+
    "\1\307\1\310\17\0\1\311\72\0\1\226\110\0\1\312"+
    "\30\0\1\312\46\0\1\312\30\0\1\312\33\0\1\313"+
    "\30\0\1\313\31\0\1\314\4\0\1\315\6\0\1\316"+
    "\1\317\14\0\1\314\4\0\1\315\5\0\1\316\1\317"+
    "\47\0\1\320\30\0\1\320\30\0\1\321\30\0\1\321"+
    "\21\0\1\322\101\0\1\323\31\0\1\323\21\0\42\324"+
    "\1\0\30\324\10\0\1\325\62\0\42\326\1\0\30\326"+
    "\11\0\1\327\110\0\1\330\30\0\1\330\46\0\1\330"+
    "\30\0\1\330\33\0\1\331\30\0\1\331\13\0\2\75"+
    "\2\0\5\75\1\121\5\75\1\332\3\75\1\333\16\75"+
    "\2\0\5\75\1\332\3\75\1\333\17\75\2\0\5\75"+
    "\1\121\16\75\1\334\11\75\2\0\15\75\1\334\13\75"+
    "\2\0\5\75\1\121\21\75\1\335\6\75\2\0\20\75"+
    "\1\335\10\75\2\0\5\75\1\121\1\75\1\336\3\75"+
    "\1\337\3\75\1\340\16\75\2\0\1\75\1\336\3\75"+
    "\1\337\3\75\1\340\15\75\17\0\1\341\3\0\1\342"+
    "\25\0\1\341\3\0\1\342\45\0\1\343\30\0\1\343"+
    "\44\0\1\344\30\0\1\344\21\0\1\345\3\0\1\346"+
    "\3\0\1\347\21\0\1\345\3\0\1\346\3\0\1\347"+
    "\25\0\1\350\126\0\1\351\72\0\1\352\45\0\1\353"+
    "\3\0\1\354\25\0\1\353\3\0\1\354\45\0\1\355"+
    "\30\0\1\355\44\0\1\356\30\0\1\356\21\0\1\357"+
    "\3\0\1\360\3\0\1\361\21\0\1\357\3\0\1\360"+
    "\3\0\1\361\44\0\1\164\30\0\1\164\50\0\1\362"+
    "\30\0\1\362\13\0\1\322\32\0\1\363\42\0\1\364"+
    "\31\0\1\364\25\0\42\324\1\365\30\324\10\0\1\325"+
    "\32\0\1\366\27\0\42\326\1\367\30\326\10\0\1\370"+
    "\126\0\1\371\72\0\1\372\26\0\2\75\2\0\5\75"+
    "\1\121\3\75\1\373\24\75\2\0\3\75\1\373\25\75"+
    "\2\0\5\75\1\121\21\75\1\374\6\75\2\0\20\75"+
    "\1\374\10\75\2\0\5\75\1\121\4\75\1\374\23\75"+
    "\2\0\4\75\1\374\24\75\2\0\5\75\1\121\17\75"+
    "\1\375\10\75\2\0\16\75\1\375\12\75\2\0\5\75"+
    "\1\121\3\75\1\376\24\75\2\0\3\75\1\376\25\75"+
    "\2\0\5\75\1\121\7\75\1\374\20\75\2\0\7\75"+
    "\1\374\21\75\2\0\5\75\1\121\22\75\1\374\5\75"+
    "\2\0\21\75\1\374\5\75\15\0\1\377\31\0\1\377"+
    "\56\0\1\u0100\30\0\1\u0100\24\0\1\u0100\31\0\1\u0100"+
    "\53\0\1\u0101\30\0\1\u0101\25\0\1\u0102\31\0\1\u0102"+
    "\44\0\1\u0100\31\0\1\u0100\53\0\1\u0100\30\0\1\u0100"+
    "\15\0\1\350\32\0\1\u0103\65\0\1\236\30\0\1\236"+
    "\20\0\1\u0104\20\0\1\236\10\0\1\u0104\17\0\1\236"+
    "\20\0\1\u0105\31\0\1\u0105\56\0\1\261\30\0\1\261"+
    "\24\0\1\261\31\0\1\261\53\0\1\u0106\30\0\1\u0106"+
    "\25\0\1\u0107\31\0\1\u0107\44\0\1\261\31\0\1\261"+
    "\53\0\1\261\30\0\1\261\34\0\1\u0108\30\0\1\u0108"+
    "\12\0\42\u0109\1\0\30\u0109\33\0\1\u010a\30\0\1\u010a"+
    "\15\0\1\u010b\63\0\42\u010c\1\0\30\u010c\7\0\1\u010d"+
    "\73\0\1\370\32\0\1\u010e\65\0\1\252\30\0\1\252"+
    "\20\0\1\u010f\20\0\1\252\10\0\1\u010f\17\0\1\252"+
    "\3\0\2\75\2\0\5\75\1\121\11\75\1\340\16\75"+
    "\2\0\11\75\1\340\17\75\2\0\5\75\1\u0110\30\75"+
    "\2\0\31\75\2\0\5\75\1\121\25\75\1\u0111\2\75"+
    "\2\0\24\75\1\u0111\4\75\2\0\5\75\1\121\3\75"+
    "\1\374\24\75\2\0\3\75\1\374\23\75\23\0\1\347"+
    "\31\0\1\347\26\0\1\u0112\120\0\1\u0113\30\0\1\u0113"+
    "\17\0\1\u0100\31\0\1\u0100\23\0\42\u0114\1\0\30\u0114"+
    "\31\0\1\u0115\30\0\1\u0115\33\0\1\361\31\0\1\361"+
    "\54\0\1\u0116\30\0\1\u0116\17\0\1\261\31\0\1\261"+
    "\37\0\1\u0117\31\0\1\u0117\24\0\42\u0109\1\u0118\30\u0109"+
    "\11\0\1\245\107\0\1\u0119\30\0\1\u0119\13\0\42\u010c"+
    "\1\u011a\30\u010c\26\0\1\u011b\30\0\1\u011b\13\0\42\u011c"+
    "\1\0\30\u011c\31\0\1\u011d\30\0\1\u011d\20\0\1\u011e"+
    "\62\0\2\75\2\0\5\75\1\121\25\75\1\374\2\75"+
    "\2\0\24\75\1\374\2\75\10\0\1\u011f\121\0\1\u0100"+
    "\30\0\1\u0100\2\0\42\u0114\1\u0120\30\u0114\30\0\1\263"+
    "\30\0\1\263\50\0\1\261\30\0\1\261\21\0\1\364"+
    "\31\0\1\364\30\0\1\u0121\110\0\1\u0122\30\0\1\u0122"+
    "\23\0\1\u0123\110\0\1\u0124\30\0\1\u0124\14\0\42\u011c"+
    "\1\u0125\30\u011c\30\0\1\277\30\0\1\277\21\0\1\u011e"+
    "\32\0\1\u0126\37\0\1\u011f\32\0\1\u0127\36\0\1\u0128"+
    "\111\0\1\u0129\30\0\1\u0129\43\0\1\u012a\30\0\1\u012a"+
    "\37\0\1\u012b\30\0\1\u012b\43\0\1\u012c\30\0\1\u012c"+
    "\20\0\1\u012d\63\0\42\u012e\1\0\30\u012e\26\0\1\u012f"+
    "\30\0\1\u012f\40\0\1\u0130\30\0\1\u0130\57\0\1\u0131"+
    "\54\0\1\u0132\30\0\1\u0132\57\0\1\u0133\55\0\1\u0134"+
    "\30\0\1\u0134\13\0\42\u012e\1\u0135\30\u012e\25\0\1\u0136"+
    "\30\0\1\u0136\44\0\1\u0137\30\0\1\u0137\41\0\1\u0138"+
    "\30\0\1\u0138\36\0\1\u0139\30\0\1\u0139\23\0\1\u013a"+
    "\113\0\1\u013b\30\0\1\u013b\54\0\1\u013c\72\0\1\u013d"+
    "\57\0\1\u013e\30\0\1\u013e\37\0\1\u013f\30\0\1\u013f"+
    "\56\0\1\u0140\30\0\2\u0140\1\0\1\u0141\35\0\1\u0142"+
    "\73\0\1\u0143\54\0\1\u0144\30\0\1\u0144\44\0\1\u0145"+
    "\30\0\1\u0145\37\0\1\u0146\30\0\1\u0146\43\0\1\u0147"+
    "\30\0\1\u0147\25\0\1\u0148\31\0\1\u0148\51\0\1\u0149"+
    "\30\0\1\u0149\57\0\1\u014a\63\0\1\u014b\30\0\1\u014b"+
    "\35\0\1\u014c\30\0\1\u014c\12\0\2\u014a\1\0\1\u014d"+
    "\2\u014a\2\0\1\u014a\30\0\1\u014e\1\0\1\u014a\60\0"+
    "\1\u014f\30\0\1\u014f\20\0\1\u0150\111\0\1\u0151\30\0"+
    "\1\u0151\37\0\1\u0152\30\0\1\u0152\25\0\1\u0140\73\0"+
    "\1\u0153\3\0\1\u0154\6\0\1\u0155\16\0\1\u0153\3\0"+
    "\1\u0154\5\0\1\u0155\27\0\1\u0156\31\0\1\u0156\51\0"+
    "\1\u0157\30\0\1\u0157\52\0\1\u0158\30\0\1\u0158\41\0"+
    "\1\u0159\30\0\1\u0159\22\0\1\u015a\31\0\1\u015a\55\0"+
    "\1\u015b\30\0\1\u015b\35\0\1\u015c\30\0\1\u015c\46\0"+
    "\1\u015d\30\0\1\u015d\50\0\1\u015e\47\0\1\u015f\31\0"+
    "\1\u015f\51\0\1\u0160\30\0\1\u0160\20\0\1\u0161\103\0"+
    "\1\u0162\31\0\1\u0162\31\0\1\u0153\12\0\1\u0155\16\0"+
    "\1\u0153\11\0\1\u0155\57\0\1\u0163\40\0\1\u014a\73\0"+
    "\1\u0164\2\0\1\u0165\1\u0166\1\u0167\5\0\1\u0168\1\0"+
    "\1\u0169\3\0\1\u016a\4\0\1\u016b\3\0\1\u0164\2\0"+
    "\1\u0165\1\u0166\1\u0167\4\0\1\u0168\1\0\1\u0169\3\0"+
    "\1\u016a\4\0\1\u016b\11\0\1\u016c\74\0\1\u0153\31\0"+
    "\1\u0153\63\0\1\u016d\30\0\1\u016d\34\0\1\u016e\30\0"+
    "\1\u016e\46\0\1\u016f\30\0\1\u016f\41\0\1\u0170\30\0"+
    "\1\u0170\22\0\1\u0171\31\0\1\u0171\57\0\1\u0172\30\0"+
    "\1\u0172\40\0\1\u0173\30\0\1\u0173\23\0\1\u0174\31\0"+
    "\1\u0174\35\0\1\u0175\1\u0176\14\0\1\u0177\13\0\1\u0175"+
    "\1\u0176\13\0\1\u0177\44\0\1\u0178\30\0\1\u0178\21\0"+
    "\1\u0179\31\0\1\u0179\67\0\1\u017a\54\0\1\u017b\30\0"+
    "\1\u017b\34\0\1\u017c\31\0\1\u017c\46\0\1\u017d\30\0"+
    "\1\u017d\44\0\1\u017e\30\0\1\u017e\22\0\1\u017f\31\0"+
    "\1\u017f\42\0\1\u0180\31\0\1\u0180\54\0\1\u0181\30\0"+
    "\1\u0181\23\0\1\u0182\31\0\1\u0182\47\0\1\u0183\31\0"+
    "\1\u0183\62\0\1\u0184\41\0\1\u0185\12\0\1\u0168\16\0"+
    "\1\u0185\11\0\1\u0168\41\0\1\u0186\30\0\1\u0186\57\0"+
    "\1\u0187\42\0\1\u0188\31\0\1\u0188\64\0\1\u0189\30\0"+
    "\1\u0189\34\0\1\u018a\30\0\1\u018a\25\0\1\u018b\31\0"+
    "\1\u018b\50\0\1\u018c\1\u018d\27\0\1\u018c\1\u018d\44\0"+
    "\1\u018e\30\0\1\u018e\17\0\1\u018f\77\0\1\u0190\31\0"+
    "\1\u0190\37\0\1\u0191\20\0\1\u016d\10\0\1\u0191\17\0"+
    "\1\u016d\47\0\1\u0192\41\0\1\u0164\31\0\1\u0164\44\0"+
    "\1\u0193\31\0\1\u0193\32\0\1\u0194\72\0\1\u0195\72\0"+
    "\1\u0196\110\0\1\u0197\30\0\1\u0197\46\0\1\u0197\30\0"+
    "\1\u0197\33\0\1\u0198\30\0\1\u0198\27\0\1\u0199\1\u019a"+
    "\14\0\1\u019b\13\0\1\u0199\1\u019a\13\0\1\u019b\22\0"+
    "\1\u019c\31\0\1\u019c\60\0\1\u019d\30\0\1\u019d\25\0"+
    "\1\u019e\31\0\1\u019e\54\0\1\u019f\30\0\1\u019f\6\0"+
    "\2\u0194\2\0\5\u0194\1\u0112\30\u0194\2\0\27\u0194\2\u0195"+
    "\2\0\5\u0195\1\u01a0\30\u0195\2\0\27\u0195\10\0\1\u01a1"+
    "\126\0\1\u01a2\72\0\1\u01a3\43\0\1\u01a4\31\0\1\u01a4"+
    "\54\0\1\u01a5\30\0\1\u01a5\23\0\1\u01a6\31\0\1\u01a6"+
    "\62\0\1\u01a7\30\0\1\u01a7\35\0\1\u01a8\30\0\1\u01a8"+
    "\46\0\1\u01a9\30\0\1\u01a9\14\0\1\u01aa\32\0\1\u01ab"+
    "\36\0\1\u01ac\72\0\1\u01a1\32\0\1\u01ad\65\0\1\u0180"+
    "\30\0\1\u0180\20\0\1\u01ae\20\0\1\u0180\10\0\1\u01ae"+
    "\17\0\1\u0180\22\0\1\u01af\31\0\1\u01af\50\0\1\u01b0"+
    "\1\u01b1\27\0\1\u01b0\1\u01b1\44\0\1\u01b2\30\0\1\u01b2"+
    "\25\0\1\u01b3\31\0\1\u01b3\51\0\1\u01b4\30\0\1\u01b4"+
    "\55\0\1\u01b5\26\0\2\u01aa\2\0\5\u01aa\1\u01b6\30\u01aa"+
    "\2\0\27\u01aa\41\0\1\u01b7\30\0\1\u01b7\10\0\1\u01ac"+
    "\32\0\1\u01b8\27\0\42\u01b9\1\0\30\u01b9\31\0\1\u01ba"+
    "\30\0\1\u01ba\21\0\1\u01bb\110\0\1\u01bc\30\0\1\u01bc"+
    "\46\0\1\u01bc\30\0\1\u01bc\33\0\1\u01bd\30\0\1\u01bd"+
    "\24\0\1\u01be\122\0\1\u01bf\30\0\1\u01bf\30\0\1\u01c0"+
    "\30\0\1\u01c0\21\0\1\u01c1\101\0\1\u01c2\31\0\1\u01c2"+
    "\21\0\42\u01c3\1\0\30\u01c3\42\u01b9\1\u01c4\30\u01b9\30\0"+
    "\1\u018d\30\0\1\u018d\21\0\1\u01c5\126\0\1\u01c6\72\0"+
    "\1\u01c7\26\0\2\u01be\2\0\5\u01be\1\u01c8\30\u01be\2\0"+
    "\27\u01be\27\0\1\u01c9\30\0\1\u01c9\50\0\1\u01ca\30\0"+
    "\1\u01ca\13\0\1\u01c1\32\0\1\u01cb\42\0\1\u01cc\31\0"+
    "\1\u01cc\25\0\42\u01c3\1\u01cd\30\u01c3\7\0\1\u01ce\73\0"+
    "\1\u01c5\32\0\1\u01cf\65\0\1\u01a4\30\0\1\u01a4\20\0"+
    "\1\u01d0\20\0\1\u01a4\10\0\1\u01d0\17\0\1\u01a4\13\0"+
    "\1\u01d1\73\0\1\u01d2\110\0\1\u01d3\30\0\1\u01d3\12\0"+
    "\42\u01d4\1\0\30\u01d4\33\0\1\u01d5\30\0\1\u01d5\15\0"+
    "\1\u01d6\111\0\1\u01d7\30\0\1\u01d7\13\0\42\u01d8\1\0"+
    "\30\u01d8\31\0\1\u01d9\30\0\1\u01d9\20\0\1\u01d1\32\0"+
    "\1\u01da\27\0\2\u01d2\2\0\5\u01d2\1\u01bb\30\u01d2\2\0"+
    "\27\u01d2\14\0\1\u01db\31\0\1\u01db\24\0\42\u01d4\1\u01dc"+
    "\30\u01d4\11\0\1\u01dd\107\0\1\u01de\30\0\1\u01de\40\0"+
    "\1\u01df\30\0\1\u01df\14\0\42\u01d8\1\u01e0\30\u01d8\30\0"+
    "\1\u01b1\30\0\1\u01b1\11\0\42\u01e1\1\0\30\u01e1\17\0"+
    "\1\u01e2\31\0\1\u01e2\30\0\1\u01e3\63\0\2\u01dd\2\0"+
    "\5\u01dd\1\u01e4\30\u01dd\2\0\27\u01dd\25\0\1\u01e5\30\0"+
    "\1\u01e5\44\0\1\u01e6\30\0\1\u01e6\20\0\1\u01e7\63\0"+
    "\42\u01e1\1\u01e8\30\u01e1\33\0\1\u01e9\30\0\1\u01e9\34\0"+
    "\1\u01ea\30\0\1\u01ea\23\0\1\u01eb\112\0\1\u01ec\30\0"+
    "\1\u01ec\54\0\1\u01ed\55\0\1\u01ee\30\0\1\u01ee\22\0"+
    "\1\u01ef\74\0\1\u01f0\106\0\1\u01f1\30\0\1\u01f1\24\0"+
    "\1\u01eb\32\0\1\u01f2\72\0\1\u01f3\54\0\1\u01f4\30\0"+
    "\1\u01f4\42\0\1\u01f5\30\0\1\u01f5\13\0\2\u01f0\2\0"+
    "\5\u01f0\1\u01f6\30\u01f0\2\0\27\u01f0\30\0\1\u01f7\30\0"+
    "\1\u01f7\11\0\42\u01f8\1\0\30\u01f8\1\0\2\u01f3\1\0"+
    "\1\u01f9\2\u01f3\2\0\1\u01f3\30\0\1\u01fa\1\0\1\u01f3"+
    "\56\0\1\u01fb\30\0\1\u01fb\36\0\1\u01fc\30\0\1\u01fc"+
    "\24\0\1\u01fd\125\0\1\u01fe\27\0\42\u01f8\1\u01ff\30\u01f8"+
    "\30\0\1\u0200\30\0\1\u0200\37\0\1\u0201\30\0\1\u0201"+
    "\56\0\1\u0202\57\0\1\u0203\30\0\1\u0203\21\0\1\u01fd"+
    "\32\0\1\u0204\30\0\2\u01fe\1\0\1\u0205\2\u01fe\2\0"+
    "\1\u01fe\30\0\1\u0206\1\0\1\u01fe\35\0\1\u0207\77\0"+
    "\1\u0208\31\0\1\u0208\51\0\1\u0209\30\0\1\u0209\15\0"+
    "\2\u0202\1\0\1\u020a\2\u0202\2\0\1\u0202\30\0\1\u020b"+
    "\1\0\1\u0202\71\0\1\u020c\27\0\42\u020d\1\0\30\u020d"+
    "\30\0\1\u020e\30\0\1\u020e\37\0\1\u020f\30\0\1\u020f"+
    "\41\0\1\u0210\30\0\1\u0210\47\0\1\u0211\30\0\1\u0211"+
    "\35\0\1\u0212\30\0\1\u0212\41\0\1\u0213\30\0\1\u0213"+
    "\37\0\1\u0214\30\0\1\u0214\14\0\2\u020c\1\0\1\u0215"+
    "\2\u020c\2\0\1\u020c\30\0\1\u0216\1\0\1\u020c\26\0"+
    "\42\u020d\1\u0217\30\u020d\14\0\1\u0218\31\0\1\u0218\51\0"+
    "\1\u0219\30\0\1\u0219\41\0\1\u021a\30\0\1\u021a\46\0"+
    "\1\u021b\30\0\1\u021b\20\0\1\u021c\75\0\1\u021d\31\0"+
    "\1\u021d\51\0\1\u021e\30\0\1\u021e\44\0\1\u021f\30\0"+
    "\1\u021f\37\0\1\u0220\30\0\1\u0220\22\0\1\u0221\117\0"+
    "\1\u0222\30\0\1\u0222\35\0\1\u0223\30\0\1\u0223\41\0"+
    "\1\u0224\30\0\1\u0224\23\0\1\u01f3\73\0\1\u0225\2\0"+
    "\1\u0165\1\u0226\1\u0167\5\0\1\u0227\1\0\1\u0169\3\0"+
    "\1\u0228\4\0\1\u016b\3\0\1\u0225\2\0\1\u0165\1\u0226"+
    "\1\u0167\4\0\1\u0227\1\0\1\u0169\3\0\1\u0228\4\0"+
    "\1\u016b\34\0\1\u0229\30\0\1\u0229\35\0\1\u022a\30\0"+
    "\1\u022a\25\0\1\u022b\31\0\1\u022b\51\0\1\u022c\30\0"+
    "\1\u022c\42\0\1\u022d\30\0\1\u022d\45\0\1\u022e\30\0"+
    "\1\u022e\20\0\1\u022f\124\0\1\u0230\65\0\1\u0231\30\0"+
    "\1\u0231\41\0\1\u0232\30\0\1\u0232\22\0\1\u0233\31\0"+
    "\1\u0233\56\0\1\u0234\30\0\1\u0234\36\0\1\u0235\30\0"+
    "\1\u0235\20\0\1\u0236\115\0\1\u0237\30\0\1\u0237\35\0"+
    "\1\u0238\30\0\1\u0238\36\0\1\u0239\30\0\1\u0239\26\0"+
    "\1\u01fe\73\0\1\u0225\2\0\1\u023a\1\u0226\1\u0167\5\0"+
    "\1\u0227\1\0\1\u0169\3\0\1\u023b\4\0\1\u016b\3\0"+
    "\1\u0225\2\0\1\u023a\1\u0226\1\u0167\4\0\1\u0227\1\0"+
    "\1\u0169\3\0\1\u023b\4\0\1\u016b\1\0\2\u0230\1\0"+
    "\1\u023c\2\u0230\2\0\1\u0230\30\0\1\u023d\1\0\1\u0230"+
    "\63\0\1\u023e\30\0\1\u023e\50\0\1\u023f\47\0\1\u0240"+
    "\31\0\1\u0240\51\0\1\u0241\30\0\1\u0241\21\0\1\u0202"+
    "\73\0\1\u0164\2\0\1\u0242\1\u0166\1\u0167\5\0\1\u0168"+
    "\1\0\1\u0243\3\0\1\u0244\4\0\1\u0245\3\0\1\u0164"+
    "\2\0\1\u0242\1\u0166\1\u0167\4\0\1\u0168\1\0\1\u0243"+
    "\3\0\1\u0244\4\0\1\u0245\32\0\1\u0246\30\0\1\u0246"+
    "\20\0\1\u0247\111\0\1\u0248\30\0\1\u0248\42\0\1\u0249"+
    "\30\0\1\u0249\45\0\1\u024a\30\0\1\u024a\34\0\1\u024b"+
    "\30\0\1\u024b\37\0\1\u024c\30\0\1\u024c\35\0\1\u024d"+
    "\31\0\1\u024d\31\0\1\u024e\12\0\1\u0227\16\0\1\u024e"+
    "\11\0\1\u0227\57\0\1\u024f\66\0\1\u018a\30\0\1\u018a"+
    "\32\0\1\u0250\30\0\1\u0250\46\0\1\u0251\30\0\1\u0251"+
    "\40\0\1\u0252\30\0\1\u0252\23\0\1\u0253\31\0\1\u0253"+
    "\33\0\1\u020c\73\0\1\u0225\2\0\1\u0165\1\u0226\1\u0167"+
    "\5\0\1\u0227\1\0\1\u0254\3\0\1\u0255\4\0\1\u016b"+
    "\3\0\1\u0225\2\0\1\u0165\1\u0226\1\u0167\4\0\1\u0227"+
    "\1\0\1\u0254\3\0\1\u0255\4\0\1\u016b\43\0\1\u0256"+
    "\44\0\1\u0257\31\0\1\u0257\55\0\1\u0258\30\0\1\u0258"+
    "\23\0\1\u0259\31\0\1\u0259\51\0\1\u025a\30\0\1\u025a"+
    "\25\0\1\u025b\76\0\1\u025c\20\0\1\u0231\10\0\1\u025c"+
    "\17\0\1\u0231\16\0\1\u0225\31\0\1\u0225\42\0\1\u025d"+
    "\31\0\1\u025d\52\0\1\u025e\30\0\1\u025e\44\0\1\u025f"+
    "\30\0\1\u025f\22\0\1\u0260\31\0\1\u0260\63\0\1\u0261"+
    "\30\0\1\u0261\40\0\1\u0262\30\0\1\u0262\5\0\2\u0263"+
    "\1\0\1\u0264\2\u0263\2\0\1\u0263\30\0\1\u0265\1\0"+
    "\1\u0263\72\0\1\u0266\66\0\1\u0267\30\0\1\u0267\35\0"+
    "\1\u0268\30\0\1\u0268\35\0\1\u0269\30\0\1\u0269\25\0"+
    "\1\u026a\1\u026b\14\0\1\u026c\13\0\1\u026a\1\u026b\13\0"+
    "\1\u026c\42\0\1\u026d\30\0\1\u026d\52\0\1\u026e\42\0"+
    "\1\u026f\31\0\1\u026f\64\0\1\u01c9\30\0\1\u01c9\34\0"+
    "\1\u01c9\30\0\1\u01c9\35\0\1\u0270\30\0\1\u0270\44\0"+
    "\1\u0271\30\0\1\u0271\37\0\1\u0272\30\0\1\u0272\37\0"+
    "\1\u0273\30\0\1\u0273\31\0\1\u0274\31\0\1\u0274\33\0"+
    "\1\u01aa\113\0\1\u0275\30\0\1\u0275\20\0\1\u0276\76\0"+
    "\1\u0277\31\0\1\u0277\54\0\1\u0278\30\0\1\u0278\23\0"+
    "\1\u0279\31\0\1\u0279\56\0\1\u027a\30\0\1\u027a\26\0"+
    "\1\u027b\31\0\1\u027b\41\0\1\u027c\31\0\1\u027c\35\0"+
    "\1\u027d\31\0\1\u027d\64\0\1\u01b3\30\0\1\u01b3\15\0"+
    "\1\u027e\31\0\1\u027e\51\0\1\u027f\30\0\1\u027f\27\0"+
    "\1\u0280\31\0\1\u0280\37\0\1\u0230\73\0\1\u0281\2\0"+
    "\1\u023a\1\u0282\1\u0167\5\0\1\u0283\1\0\1\u0254\3\0"+
    "\1\u0284\4\0\1\u01b7\3\0\1\u0281\2\0\1\u023a\1\u0282"+
    "\1\u0167\4\0\1\u0283\1\0\1\u0254\3\0\1\u0284\4\0"+
    "\1\u01b7\17\0\1\u0285\31\0\1\u0285\50\0\1\u0286\1\u0287"+
    "\27\0\1\u0286\1\u0287\44\0\1\u0288\30\0\1\u0288\36\0"+
    "\1\u0289\30\0\1\u0289\24\0\1\u028a\31\0\1\u028a\60\0"+
    "\1\u028b\30\0\1\u028b\25\0\1\u028c\31\0\1\u028c\55\0"+
    "\1\u028d\30\0\1\u028d\35\0\1\u028e\30\0\1\u028e\46\0"+
    "\1\u028f\30\0\1\u028f\42\0\1\u0290\30\0\1\u0290\41\0"+
    "\1\u0291\30\0\1\u0291\22\0\1\u0292\31\0\1\u0292\56\0"+
    "\1\u0293\30\0\1\u0293\15\0\1\u01a0\110\0\1\u0294\30\0"+
    "\1\u0294\46\0\1\u0294\30\0\1\u0294\33\0\1\u0295\30\0"+
    "\1\u0295\54\0\1\u0296\30\0\1\u0296\35\0\1\u0297\30\0"+
    "\1\u0297\15\0\1\u0298\32\0\1\u0299\61\0\1\u029a\30\0"+
    "\1\u029a\40\0\1\u029b\30\0\1\u029b\20\0\1\u029c\100\0"+
    "\1\u01d5\31\0\1\u01d5\56\0\1\u029d\30\0\1\u029d\50\0"+
    "\1\u029e\47\0\1\u029f\31\0\1\u029f\51\0\1\u02a0\30\0"+
    "\1\u02a0\53\0\1\u02a1\72\0\1\u02a2\55\0\1\u018a\30\0"+
    "\1\u018a\31\0\1\u02a3\31\0\1\u02a3\21\0\2\u0298\2\0"+
    "\5\u0298\1\u02a4\30\u0298\2\0\27\u0298\41\0\1\u02a5\30\0"+
    "\1\u02a5\11\0\1\u01dd\32\0\1\u01ab\40\0\1\u0263\73\0"+
    "\1\u02a6\2\0\1\u02a7\1\u02a8\1\u0167\5\0\1\u02a9\1\0"+
    "\1\u02aa\3\0\1\u02ab\4\0\1\u02a5\3\0\1\u02a6\2\0"+
    "\1\u02a7\1\u02a8\1\u0167\4\0\1\u02a9\1\0\1\u02aa\3\0"+
    "\1\u02ab\4\0\1\u02a5\22\0\1\u02ac\31\0\1\u02ac\31\0"+
    "\1\u02ad\12\0\1\u0283\16\0\1\u02ad\11\0\1\u0283\57\0"+
    "\1\u02ae\66\0\1\u01d5\30\0\1\u01d5\37\0\1\u0277\30\0"+
    "\1\u0277\20\0\1\u02af\20\0\1\u0277\10\0\1\u02af\17\0"+
    "\1\u0277\14\0\1\u02b0\71\0\1\u02b1\101\0\1\u02b2\31\0"+
    "\1\u02b2\57\0\1\u02b3\30\0\1\u02b3\34\0\1\u02b4\30\0"+
    "\1\u02b4\46\0\1\u02b5\30\0\1\u02b5\22\0\1\u02b6\31\0"+
    "\1\u02b6\57\0\1\u02b7\30\0\1\u02b7\40\0\1\u02b8\30\0"+
    "\1\u02b8\15\0\1\u02b9\76\0\1\u02ba\20\0\1\u0290\10\0"+
    "\1\u02ba\17\0\1\u0290\16\0\1\u0281\31\0\1\u0281\56\0"+
    "\1\u02bb\30\0\1\u02bb\10\0\2\u02b0\2\0\5\u02b0\1\u02bc"+
    "\30\u02b0\2\0\27\u02b0\10\0\1\u02b1\32\0\1\u02bd\42\0"+
    "\1\u01e2\31\0\1\u01e2\62\0\1\u02be\30\0\1\u02be\21\0"+
    "\1\u02bf\31\0\1\u02bf\67\0\1\u02c0\47\0\1\u02c1\31\0"+
    "\1\u02c1\46\0\1\u02c2\30\0\1\u02c2\44\0\1\u02c3\30\0"+
    "\1\u02c3\23\0\1\u02c4\1\u02c5\14\0\1\u02c6\13\0\1\u02c4"+
    "\1\u02c5\13\0\1\u02c6\42\0\1\u02c7\30\0\1\u02c7\36\0"+
    "\1\u0287\30\0\1\u0287\21\0\1\u02c8\62\0\42\u02c9\1\0"+
    "\30\u02c9\22\0\1\u02ca\31\0\1\u02ca\62\0\1\u02cb\41\0"+
    "\1\u02cc\12\0\1\u02a9\16\0\1\u02cc\11\0\1\u02a9\57\0"+
    "\1\u02cd\42\0\1\u02ce\31\0\1\u02ce\64\0\1\u02cf\30\0"+
    "\1\u02cf\16\0\1\u02d0\31\0\1\u02d0\54\0\1\u02d1\30\0"+
    "\1\u02d1\23\0\1\u02d2\31\0\1\u02d2\56\0\1\u02d3\30\0"+
    "\1\u02d3\20\0\1\u02c8\32\0\1\u02d4\27\0\42\u02c9\1\u02d5"+
    "\30\u02c9\11\0\1\u02d6\77\0\1\u02d7\31\0\1\u02d7\37\0"+
    "\1\u02d8\20\0\1\u02b3\10\0\1\u02d8\17\0\1\u02b3\16\0"+
    "\1\u02a6\31\0\1\u02a6\44\0\1\u02d9\31\0\1\u02d9\32\0"+
    "\1\u02da\100\0\1\u02db\31\0\1\u02db\50\0\1\u02dc\1\u02dd"+
    "\27\0\1\u02dc\1\u02dd\44\0\1\u02de\30\0\1\u02de\36\0"+
    "\1\u02df\30\0\1\u02df\11\0\42\u02e0\1\0\30\u02e0\7\0"+
    "\1\u02e1\77\0\1\u02e2\1\u02e3\14\0\1\u02e4\13\0\1\u02e2"+
    "\1\u02e3\13\0\1\u02e4\22\0\1\u02e5\31\0\1\u02e5\60\0"+
    "\1\u02e6\30\0\1\u02e6\41\0\1\u02e7\30\0\1\u02e7\6\0"+
    "\2\u02da\2\0\5\u02da\1\u02e8\30\u02da\2\0\27\u02da\11\0"+
    "\1\u02e9\110\0\1\u02ea\30\0\1\u02ea\46\0\1\u02ea\30\0"+
    "\1\u02ea\33\0\1\u02eb\30\0\1\u02eb\54\0\1\u02ec\30\0"+
    "\1\u02ec\42\u02e0\1\u02ed\30\u02e0\26\0\1\u02ee\30\0\1\u02ee"+
    "\30\0\1\u02ef\31\0\1\u02ef\54\0\1\u02f0\30\0\1\u02f0"+
    "\23\0\1\u02f1\31\0\1\u02f1\62\0\1\u02f2\30\0\1\u02f2"+
    "\35\0\1\u02f3\30\0\1\u02f3\21\0\1\u01f0\32\0\1\u0299"+
    "\36\0\1\u02f4\72\0\1\u02f5\126\0\1\u02f6\72\0\1\u02f7"+
    "\55\0\1\u01d5\30\0\1\u01d5\21\0\1\u02f8\110\0\1\u02f9"+
    "\30\0\1\u02f9\33\0\1\u02fa\31\0\1\u02fa\50\0\1\u02fb"+
    "\1\u02fc\27\0\1\u02fb\1\u02fc\44\0\1\u02fd\30\0\1\u02fd"+
    "\25\0\1\u01e9\31\0\1\u01e9\51\0\1\u02fe\30\0\1\u02fe"+
    "\21\0\1\u02f4\32\0\1\u02ff\37\0\1\u02f5\32\0\1\u0300"+
    "\65\0\1\u02d0\30\0\1\u02d0\20\0\1\u0301\20\0\1\u02d0"+
    "\10\0\1\u0301\17\0\1\u02d0\31\0\1\u0302\30\0\1\u0302"+
    "\43\0\1\u0303\30\0\1\u0303\22\0\1\u01f6\110\0\1\u0304"+
    "\30\0\1\u0304\46\0\1\u0304\30\0\1\u0304\33\0\1\u0305"+
    "\30\0\1\u0305\54\0\1\u0306\30\0\1\u0306\42\u0307\1\0"+
    "\30\u0307\42\u0308\1\0\30\u0308\31\0\1\u0309\30\0\1\u0309"+
    "\35\0\1\u030a\30\0\1\u030a\57\0\1\u030b\73\0\1\u030c"+
    "\72\0\1\u030d\55\0\1\u01e9\30\0\1\u01e9\12\0\42\u0307"+
    "\1\u030e\30\u0307\42\u0308\1\u030f\30\u0308\30\0\1\u02dd\30\0"+
    "\1\u02dd\41\0\1\u0310\30\0\1\u0310\12\0\2\u030b\1\0"+
    "\1\u0311\2\u030b\2\0\1\u030b\30\0\1\u0312\1\0\1\u030b"+
    "\64\0\1\u02ef\30\0\1\u02ef\20\0\1\u0313\20\0\1\u02ef"+
    "\10\0\1\u0313\17\0\1\u02ef\12\0\1\u0314\72\0\1\u0315"+
    "\126\0\1\u0316\57\0\1\u0317\30\0\1\u0317\37\0\1\u0318"+
    "\30\0\1\u0318\44\0\1\u0319\30\0\1\u0319\36\0\1\u031a"+
    "\30\0\1\u031a\41\0\1\u031b\30\0\1\u031b\14\0\2\u0316"+
    "\1\0\1\u031c\2\u0316\2\0\1\u0316\30\0\1\u031d\1\0"+
    "\1\u0316\42\0\1\u031e\31\0\1\u031e\51\0\1\u031f\30\0"+
    "\1\u031f\44\0\1\u02fc\30\0\1\u02fc\36\0\1\u0320\30\0"+
    "\1\u0320\41\0\1\u0321\30\0\1\u0321\44\0\1\u0322\30\0"+
    "\1\u0322\37\0\1\u0323\30\0\1\u0323\47\0\1\u0324\30\0"+
    "\1\u0324\35\0\1\u0325\30\0\1\u0325\41\0\1\u0326\30\0"+
    "\1\u0326\41\0\1\u0327\30\0\1\u0327\25\0\1\u0328\31\0"+
    "\1\u0328\51\0\1\u0329\30\0\1\u0329\46\0\1\u032a\30\0"+
    "\1\u032a\20\0\1\u032b\124\0\1\u0263\72\0\1\u032c\63\0"+
    "\1\u032d\30\0\1\u032d\35\0\1\u032e\30\0\1\u032e\23\0"+
    "\1\u030b\73\0\1\u0164\2\0\1\u02a7\1\u0166\1\u0167\5\0"+
    "\1\u0168\1\0\1\u0243\3\0\1\u032f\4\0\1\u0245\3\0"+
    "\1\u0164\2\0\1\u02a7\1\u0166\1\u0167\4\0\1\u0168\1\0"+
    "\1\u0243\3\0\1\u032f\4\0\1\u0245\32\0\1\u0330\30\0"+
    "\1\u0330\20\0\1\u0331\116\0\1\u0332\30\0\1\u0332\16\0"+
    "\1\u0316\73\0\1\u0164\2\0\1\u0242\1\u0166\1\u0167\5\0"+
    "\1\u0168\1\0\1\u02aa\3\0\1\u0333\4\0\1\u0245\3\0"+
    "\1\u0164\2\0\1\u0242\1\u0166\1\u0167\4\0\1\u0168\1\0"+
    "\1\u02aa\3\0\1\u0333\4\0\1\u0245\32\0\1\u0334\30\0"+
    "\1\u0334\44\0\1\u0335\30\0\1\u0335\44\0\1\u0336\30\0"+
    "\1\u0336\33\0\1\u0337\30\0\1\u0337\20\0\1\u0298\121\0"+
    "\1\u02a3\30\0\1\u02a3\1\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[47613];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\4\0\1\11\1\1\1\11\1\1\1\11\3\1\1\11"+
    "\1\1\25\0\1\11\123\0\1\11\255\0\1\1\12\0"+
    "\1\11\1\0\1\11\10\0\1\11\1\1\5\0\1\11"+
    "\251\0\1\11\150\0\1\1\325\0\1\1\13\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[823];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S160_ReferencesEuropeanLegislation() { }
	
	private String context = "";

	//Text of a single citation
	private StringBuilder text = new StringBuilder();
	
	//Textual buffer between single citations
	private StringBuilder buffer = new StringBuilder();
	
	private ArrayList<AnnotationEntity> references = new ArrayList<AnnotationEntity>(); //collection dei Reference presenti nello stesso Pattern

	private void startReference() {
	
		text = new StringBuilder();
		buffer = new StringBuilder();
		references = new ArrayList<AnnotationEntity>();
		
		annotationEntity = new Reference(Entity.LEG_REF);
		references.add(annotationEntity);
		
		context = Util.removeAllAnnotations(yytext());
		((Reference) annotationEntity).setContext(context);
		
		annotationEntity.setPosition(position);

		length = yylength();		
	
		yypushback(length);
		offset = 0;
	
		yybegin(referenceState);	 
	}
	
	private void checkReference() {
	
		if( ((Reference) annotationEntity).isReference() ) {
		
			((Reference) annotationEntity).setText(Util.removeAllAnnotations(text.toString()));
			((Reference) annotationEntity).setContext(context.toString());
			
			//Add shared features
			for(Entity key : ((Reference) annotationEntity).name2sharedEntity.keySet()) {
				
				if(annotationEntity.getRelatedEntity(key) == null) {
					
					annotationEntity.addRelatedEntity(((Reference) annotationEntity).name2sharedEntity.get(key));
				}
			}
			
			//Add inverse related properties
			for(AnnotationEntity relatedEntity : annotationEntity.getRelatedEntities()) {
			
				relatedEntity.addRelatedEntity(annotationEntity);
			}
			
			addEntity(annotationEntity);
			
		} else {
			
			addText(text.toString());
		}

		addText(buffer.toString());
		
		text = new StringBuilder();
		text.append(yytext());
		buffer = new StringBuilder();
	
		Reference newAnnotationEntity = new Reference(Entity.LEG_REF);
		
		references.add(newAnnotationEntity);
		
		newAnnotationEntity.setPosition(position);
		newAnnotationEntity.setContext(context);
		
		newAnnotationEntity.name2sharedEntity.putAll(((Reference) annotationEntity).name2sharedEntity);		
		
		annotationEntity = newAnnotationEntity;
	}

	private void readFeature(boolean isShared) {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		
		offset += yylength();

		if(isShared) {
		
			((Reference) annotationEntity).name2sharedEntity.put(retrievedEntity.getEntity(), retrievedEntity);
		}
		
		if(annotationEntity.getRelatedEntity(retrievedEntity.getEntity()) != null || 
			(retrievedEntity.getEntity().equals(Entity.FULL_EU_NUMBER) && annotationEntity.getRelatedEntity(Entity.NUMBER_YEAR) != null) ||
			(retrievedEntity.getEntity().equals(Entity.NUMBER_YEAR) && annotationEntity.getRelatedEntity(Entity.FULL_EU_NUMBER) != null)
			) {

			checkReference();

		} else {
		
			text.append(buffer.toString());
			text.append(yytext());
			buffer = new StringBuilder();
		}

		annotationEntity.addRelatedEntity(retrievedEntity);
		
		position += retrievedEntity.getText().length();
	}

	private void startPropagateAuthority() {
	
		yypushback(yylength());
		
		yybegin(propagateAuthorityState);	
	}

	private void propagateAuthority(Entity authorityName) {
	
		readFeature(true);
		
		AnnotationEntity authorityEntity = retrieveEntity();
		
		if(references.size() > 1) {
		
			for(AnnotationEntity item : references) {
			
				if(item != annotationEntity && item.getRelatedEntity(authorityName) == null) {
				
					item.addRelatedEntity(authorityEntity);
				}
			}
		}
				
		yybegin(referenceState);
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S160_ReferencesEuropeanLegislation(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 13: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 14: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}
			
			checkReference();
			
			yybegin(0);

		} else {

			buffer.append(yytext());
		}
            }
          // fall through
          case 15: break;
          case 4:
            { offset++;
		position++;

		buffer.append(yytext());
            }
          // fall through
          case 16: break;
          case 5:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 17: break;
          case 6:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 18: break;
          case 7:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		offset += yylength();
		position += retrievedEntity.getText().length();
		buffer.append(yytext());
            }
          // fall through
          case 19: break;
          case 8:
            { readFeature(true);
            }
          // fall through
          case 20: break;
          case 9:
            { readFeature(false);
            }
          // fall through
          case 21: break;
          case 10:
            { propagateAuthority(Entity.EU_LEG_AUTH);
            }
          // fall through
          case 22: break;
          case 11:
            { startPropagateAuthority();
            }
          // fall through
          case 23: break;
          case 12:
            { startReference();
            }
          // fall through
          case 24: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S160_ReferencesEuropeanLegislation [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S160_ReferencesEuropeanLegislation scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S160_ReferencesEuropeanLegislation(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
